# # sample index page with internationalization (T)

def index():
    if not session.m:
        session.flash="!!! ATTENTION !!! Site en cours de TESTS merci de votre compréhention et participation."
    redirect(URL(r=request,f='listes',args=['Tous']))
    return dict()
    
def aide():
    return dict(message="ici une page d'aide... pour le moment Version au: 24 juin 2009 ")
    
                
    
@auth.requires_login()
def vote():
    #si le vote n'est pas valide (bulletin créé en Question X et voté en Question Y..(avec plusieurs questions ouvertes))
    if request.args[0]!=session.q:
        session.flash="vote NON VALIDE ! vous devez voter dans la zone du dernier bulletin préparé %s %s" %(request.args[0],session.q)
        redirect(URL(r=request,f="listes"))

    la_Q=db(db.Questions.id==request.args[0]).select()[0]
    #si date de cloture dépassée 
    if la_Q.date_limite<request.now:
        session.flash="LA DATE DE CLOTURE POUR CETTE QUESTION EST DEPASEE...désolé,vous ne pouvez pas voter !"
        redirect(URL(r=request,f="listes"))

    #si le vote est valide    
    bulletin=''.join(session.v)
    old_vote=(db.Votes.U_id==auth.user.id)&(db.Votes.Q_id==request.args[0])
    
    if not session.d:session.d=0  #si vote non délégué =>0
    #si ancien vote existant
    if len(db(old_vote).select())>0:
        for v in db(old_vote).select():          
            old_bulletin=v.Buletin                                          
            old_matchs=matching(request.args[0],old_bulletin,v.date_vote)
            
        db(old_vote).update(D_id=session.d,
                            Buletin=bulletin,
                            date_vote=request.now)
                            
        matchs=matching(request.args[0],bulletin,request.now)
        update_resultat(request.args[0],matchs,old_matchs)
        session.flash="Votre vote a été mis à jour..."
    #si pas d'ancien vote    
    else:
        vote_id=db.Votes.insert(Q_id=request.args[0],
                                U_id=auth.user.id,
                                D_id=session.d,
                                Buletin=bulletin,
                                date_vote=request.now)
        ##la_Q=db(db.Questions.id==request.args[0]).select()[0] 
        matchs=matching(request.args[0],bulletin,request.now)                       
        db(db.Questions.id==request.args[0]).update(nbr_votes=la_Q.nbr_votes+1)
        update_resultat(request.args[0],matchs)
        
        session.flash="Votre vote a été enregistré..." 
    session.d=0 #annulation de la délégation éventuelle pour la suite
    redirect(URL(r=request,f="listes"))
    return dict()
    
def str_to_dict(chaine):
    dico={}
    if chaine==None or chaine=='{}':
        return dico
    chaine=chaine.replace(' ','')
    chaine=chaine.replace('{','')
    chaine=chaine.replace('}','')
    chaine=chaine.replace("'",'')
    liste=chaine.split(',')
    for elem in liste:
        l_e=elem.split(':')
        dico[l_e[0]]=int(l_e[1])
    return dico
    
def update_resultat(Q_id,matchs,old_matchs=[]):
    resultat={}
    la_Q=db(db.Questions.id==Q_id).select()[0]
    resultat=str_to_dict(la_Q.resultat)
    old_resultat=resultat.copy()
    #on décrémente les anciens matchs
    for m in old_matchs:
        resultat[m]=resultat[m]-1
    #on incrémente les nouveaux matchs    
    for m in matchs:
        try:
            resultat[m]+=1
        except:
            resultat[m]=1
        
    db(db.Questions.id==Q_id).update(resultat=resultat)
    #session.flash="matchs... %s vers %s  ** resultat...%s  vers %s" %(old_matchs,matchs,old_resultat,resultat)
    
def matching(Q_id,bulletin,date_vote):
    matchs=[]
    liste_rns=[]
    #liste des réponses sélectionnées
    liste=bulletin.split('_')[1:]
    
    #liste des réponses non sélectionnées
    #prise en compte de la date pour les mises à jour (pour ne pas annuler un match sur question inexistante au temps du vote...)
    for j in  db(db.Reponses.Q_id==Q_id).select(db.Reponses.ALL):
        if str(j.id) not in liste and j.date_postee<=date_vote:
            liste_rns.append(str(j.id))
        
    liste_b=liste+liste_rns
    for r in liste:
        for r2 in liste_b[liste_b.index(r)+1:]:
            couple=r+'>'+r2
            matchs.append(couple)
    return matchs
    
@auth.requires_login()    
def new_Q():
    #form=SQLFORM(db.Questions)
    form=FORM(TABLE(TR("Votre question:",
                       TEXTAREA(_name="new_desc",requires=(IS_NOT_EMPTY()))),
                    TR("Date limite :",
                       INPUT(_id="datelimite",_name="datelimite",_class="datetime",requires=IS_DATETIME())),
                    TR(INPUT(_type='submit',_value='Valider')))) 
    if form.accepts(request.vars,session):
        final_Q=form.vars.new_desc.strip().lower().capitalize()
        Q_id=db.Questions.insert(description=final_Q,date_limite=form.vars.datelimite)
        session.flash="Nouvelle Question prise en compte.."
        redirect(URL(r=request,f="listes",args=['Tous']))
    return dict(form=form)
    
    
@auth.requires_login()
def new_R():
    db.Reponses.Q_id.default=request.args[0]
    form=FORM(TABLE(TR('Votre proposition :',
                       INPUT(_type='text',_style="width:600px",_name="new_rep",requires=(IS_NOT_EMPTY())),
                       INPUT(_type='submit',_value='Valider'))))    
    if form.accepts(request.vars,session):
        final_rep=form.vars.new_rep.strip().lower().capitalize()
        rep_id=db.Reponses.insert(titre=final_rep)
        
        session.flash="Nouvelle Réponse prise en compte.."
        redirect(URL(r=request,f="listes"))
        
    row=db(db.Questions.id==request.args[0]).select(db.Questions.ALL)[0]
    question=row.description
        
    return dict(Q_id=request.args[0],question=question,form=form)
    
@auth.requires_login()  #membership('Administrateurs')
def new_T():
    tags_existants=[]
    tags=db().select(db.Tags.ALL)
    for t in tags:
        tags_existants.append(t.titre)
    #tags_existants=tags_existants.sort()
    
    form = FORM(TABLE(TR('Nouveau Sujet:', INPUT(_type='text', _name='tag',requires=(IS_NOT_EMPTY(),IS_NOT_IN_DB(db,'Tags.titre'))),
                                           INPUT(_type='submit',_value='Valider'))))

    if form.accepts(request.vars,session):
        final_tag=form.vars.tag.strip().lower().capitalize()

        if final_tag in tags_existants or final_tag=='Tous' :
            session.flash = 'Sujet non valide ou existant'
            redirect(URL(r=request,f="listes"))
        else:
            tags_id=db.Tags.insert(titre=form.vars.tag)
            session.flash="Nouveau Tag créé..."
            redirect(URL(r=request,f="listes"))
    elif form.errors:
        session.flash = 'Sujet non valide ou existant'
        redirect(URL(r=request,f="listes"))
    return dict(tags_existants=tags_existants,form=form)

@auth.requires_login()
def add_T():
    message=''
    existe=0
    db.Tags_Questions.Q_id.default=request.args[0]
    form=SQLFORM(db.Tags_Questions)
    if form.accepts(request.vars,session):
        for Tnum in db(db.Tags_Questions.Q_id==request.args[0]).select(db.Tags_Questions.ALL):
            if str(Tnum.T_id)==form.vars.T_id:
                existe+=1
                if existe>1:
                    db(db.Tags_Questions.id==form.vars.id).delete()
                    message="existait déjà"
        session.flash="Nouveau Tag pris en compte...%s" %message
        redirect(URL(r=request,f="listes"))
    return dict(form=form)


    
def listes():
    if request.args:
        session.tag=request.args[0]
    if not session.aut:session.aut=('Tous','Tous') # (id,nom)
     
    if session.tag=='Tous':
        if session.aut[0]=='Tous':       
            questions=db(db.Questions.visibilite=='True').select(db.Questions.ALL)
        else:
            questions=db((db.Questions.auteur_id==session.aut[0])
                         &(db.Questions.visibilite=='True')).select(db.Questions.ALL)
    else:
        if session.aut[0]=='Tous':       
            questions=db((db.Questions.visibilite=='True')
                        &(db.Tags_Questions.T_id==session.tag)
                        &(db.Tags_Questions.Q_id==db.Questions.id)).select(db.Questions.ALL)
        else:
            questions=db((db.Tags_Questions.T_id==session.tag)
                        &(db.Tags_Questions.Q_id==db.Questions.id)
                        &(db.Questions.auteur_id==session.aut[0])
                        &(db.Questions.visibilite=='True')).select(db.Questions.ALL)

    #Sélecteurs  ******************
    #de Tags
    dico_tags={'Tous':'Tous'}
    for t in db().select(db.Tags.ALL):
        dico_tags[str(t.id)]=t.titre
        
    liste_tags=[dico_tags[str(session.tag)]]
    for t in dico_tags.keys():
        if t != str(session.tag):
            liste_tags.append(dico_tags[t])
            
    #d'Auteurs
    dico_auts={'Tous':'Tous'}

    for q in db().select(db.Questions.ALL):
        if q.auteur_id not in dico_auts.keys():
            a=db(db.auth_user.id==q.auteur_id).select(db.auth_user.ALL)[0]
            auteur=a.first_name+' '+a.last_name
            dico_auts[q.auteur_id]=auteur
            
    liste_auts=[session.aut[1]]
    for a in dico_auts.keys():
        if a != session.aut[0] and dico_auts[a] not in liste_auts:
            liste_auts.append(dico_auts[a])
            

            
    form_choix_T=FORM(TABLE(TR("Sélection par: Sujet ",SELECT(liste_tags,_name="Tag_choisi",requires=IS_IN_SET(liste_tags)),
                               "Auteur  ",SELECT(liste_auts,_name="Aut_choisi",requires=IS_IN_SET(liste_auts)),
                               "",     INPUT(_type="submit",_value="Envoi"))))
                               
    if form_choix_T.accepts(request.vars,session): 
        for t in dico_tags:
            if dico_tags[t]==form_choix_T.vars.Tag_choisi:
                tag_num=t
        for a in dico_auts:
            if dico_auts[a]==form_choix_T.vars.Aut_choisi:
                session.aut=(a,dico_auts[a])
        #tag_num=dico_tags[form_choix_T.vars.Tag_choisi]
        redirect(URL(r=request,f='listes',args=[tag_num]))
    return dict(questions=questions,form_choix_T=form_choix_T)

def data():
    #Utilisée pour la mise à jour de la liste des réponses sélectionnées (Ajax)
    if not session.m:session.m=[]
    if not session.v:session.v=[]
    for clef in request.vars:
        if 'champ' in clef:
            q=clef[5:clef.find('_')]
            if not session.q or session.q!=q:
                session.m=[]
                session.v=[]
                session.q=q
            r=clef[clef.find('_'):]
            if request.vars[clef] in session.m:
                idx=session.m.index(request.vars[clef])
                del(session.m[idx])
                del(session.v[idx])
            session.m.append(request.vars[clef])
            session.v.append(r)
    return TABLE(*[TR(v) for v in session.m]).xml()
    
def clear_target():
    #Nettoyage de la Zone "target" d'affichage des réponses sélectionnées
    session.m=[]
    session.v=[]
    
    return TABLE(*[TR(v) for v in session.m]).xml()
           
        
# # uncomment the following if you have defined "auth" and "crud" in models
def user(): return dict(form=auth())
# def data(): return dict(form=crud())
# def download(): return response.download(request,db)
# # tip: use @auth.requires_login, requires_membership, requires_permission
